/** Codigo fonte livre que implementa um canvas para a arvore de busca
 * binaria
 * 
 * @author Renato de Souza-4 semestre-Engenharia de Computao
 * email: renato.engcomp@gmail.com
 * */

import java.awt.*;

public class canvasDig extends Canvas{
    Dimension dimensoes;
    Busca tree;
    final int MENOR = 10;
    final int MAIOR = 20;
    
 	final int WIDTH = 400;
	final int HEIGHT = 300;
	
	/*construtor do canvas*/
	public canvasDig(Busca tree)
	{
		this.tree=tree;
		dimensoes = new Dimension(WIDTH,HEIGHT);
		/*Define o tamanho da janela para o canvas*/
        setMinimumSize(dimensoes);
        setPreferredSize(dimensoes);
	}
	
	/*Pinta o canvas no componemte grafico*/
    public void paint(Graphics g) {

        if(tree.raiz != null) {
           desenhaArvore(g,tree.raiz,0,dimensoes.width,20, 0, 0);
        } else {
           g.drawString("Arvore Vazia",dimensoes.width/2,dimensoes.height/2);

        }

    }

    /*desenha o arvore de Busca Digital*/
   private void desenhaArvore(Graphics g, SNo no,  int i, int f, int linha, int xPai, int yPai) {
       if(no==null) return;
       
       int diametroCirculos;
       if(no.marca) diametroCirculos=MAIOR;
       else diametroCirculos=MENOR;

       desenhaVertice(g, diametroCirculos , i+((f-i)/2) , linha, xPai, yPai);

       if(no.Zero != null) desenhaArvore(g,no.Zero,i,i+((f-i)/2),linha+(diametroCirculos*2), i+((f-i)/2), linha);
       if(no.Um != null) desenhaArvore(g,no.Um,i+((f-i)/2),f,linha+(diametroCirculos*2), i+((f-i)/2), linha);


   }


    private void desenhaVertice(Graphics g, int diametro, int x, int y, int xPai, int yPai) {

        int raio = diametro/2;
    	
        g.setColor(Color.black);
        if(xPai != 0) {
           g.drawLine(xPai,yPai,x,y);
        }



        g.setColor(Color.gray);
        g.fillOval(x-raio+4,y-raio+4,diametro,diametro);
        if(diametro==MAIOR) g.setColor(Color.cyan);
        else g.setColor(Color.red);
        g.fillOval(x-raio,y-raio,diametro,diametro);
	
 
    }
}
